<?php

namespace Modules\Product\Requests\Admin;

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\Rule;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;

class ProductRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        $role = ['super_admin', 'admin'];
        if (! Auth::check()) {
            return false;
        }
        if(!in_array(Auth::user()->role, $role))
        {
            return false;
        }
        if(Auth::user()->hasModule('products'))
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $rules=[
            'category_id'=>[
                'required',
                'exists:categories,id'
            ],
            'sub_category_id'=>[
                'required',
                'exists:categories,id'
            ],
            'code'=>[
                'required',
                Rule::unique('products')->ignore($this->product? $this->product->id : 0, 'id')
            ],
            'count'=>[
                'required',
                'numeric',
                'min:0'
            ],
            'warranty'=>[
                'sometimes',
                'nullable',
                'numeric',
                'min:0'
            ],
            'cost'=>[
                'required',
                'numeric',
                'min:0'
            ],
            'cost_discount'=>[
                'sometimes',
                'nullable',
                'numeric',
                'min:0',
                'lt:cost'
            ],
        ];

        foreach (languages() as $lang)
        {
            $lang_rules=[
                'title_'.$lang->local=> 'required|max:250',
                'description_'.$lang->local=> 'required',
                'items.*.title_'.$lang->local=> 'required|max:250',
                'items.*.description_'.$lang->local=> 'required|max:250',
            ];
            $rules= array_merge($rules, $lang_rules);
        }


        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {

        $attributes= [
            'category_id'=>__('products.category_id'),
            'sub_category_id'=>__('products.sub_category_id'),
            'code'=>__('products.code'),
            'count'=>__('products.count'),
            'warranty'=>__('products.warranty'),
            'cost'=>__('products.cost'),
            'cost_discount'=>__('products.cost_discount'),
        ];
        foreach (languages() as $lang) {
            $lang_attributes=[
                'title_'.$lang->local => $service->{'title_'.$lang->local} ?? __('products.title').' '.$lang->local,
                'description_'.$lang->local => $service->{'description_'.$lang->local} ?? __('products.description').' '.$lang->local,
            ];
            $attributes= array_merge($attributes, $lang_attributes);
        }
        if( !is_null( request('items') ) )
        {
            $i = 0;
            foreach(request('items') as $key=>$row)
            {
                foreach (languages() as $lang)
                {
                    $lang_attribute=[
                        'items.'.$key.'.title_'.$lang->local => __('products.title').' '. __('products.item') .' ' .$lang->local. ' ( '. ($i+1) . ' )',
                        'items.'.$key.'.description_'.$lang->local => __('products.description').' '. __('products.item') .' '.$lang->local. ' ( '. ($i+1) . ' )',
                    ];
                    $attributes= array_merge($attributes, $lang_attribute);
                }
                ++$i;
            }
        }
        return $attributes;
    }

    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            // Do the original action of the Form request class
            parent::failedValidation($validator);
        }
    }
}
